const system = require("../../../system");
const ServiceBase = require("../../sve.base")
const settings = require("../../../../config/settings")
const moment = require("moment");

class IborderbaseService extends ServiceBase {
  constructor() {
    super("order", ServiceBase.getDaoName(IborderbaseService));
    this.orderSve_1 = system.getObject("service.order.iborderSve");
    this.orderSve_2 = system.getObject("service.order.iborderdkSve");
    this.orderSve_3 = system.getObject("service.order.iborderdzSve");
  }

  /**
   * 创建基类订单
   * @param {*} params 
   */
  apiCreateOrder(params) {
    // if(!params.productType){
    //   return system.getResult(null, `参数错误 产品类型错误`);
    // }
    // if(!params.productItems instanceof Array){
    //   return system.getResult(null, `参数错误 产品项目错误`);
    // }
    // if(!params.channelNo){
    //   return system.getResult(null, `参数错误 渠道名称错误`);
    // }
    // if(!params.thirdNo){
    //   return system.getResult(null, `参数错误 订单错误`);
    // }
    // if(!Number(params.price)<0){
    //   return system.getResult(null, `参数错误 订单价格错误`);
    // }
    // if(!params.payType){
    //   return system.getResult(null, `参数错误 支付方式错误`);
    // }
    // if(!params.legalName){
    //   return system.getResult(null, `参数错误 联系人不能为空`);
    // }
    // if(!params.legalMobile){
    //   return system.getResult(null, `参数错误 联系电话不能为空`);
    // }
    // if(!params.invoiceType){
    //   return system.getResult(null, `参数错误 发票类型错误`);
    // }

    try {
      params.channelNo = this.trim(params.channelNo);
      params.thirdNo = this.trim(params.thirdNo);
      params.notes = this.trim(params.notes);
      params.legalName = this.trim(params.legalName);
      params.legalMobile = this.trim(params.legalMobile);
      params.legalEmail = this.trim(params.legalEmail);
      params.payType = Number(params.payType || 1);
      params.productType = Number(params.productType || 1);
      params.price = Number(params.price || 0);
      //1 保存基类的信息
      await this.db.transaction(async t => {

        //创建基类表
        let _baseOrder = await this.create(params);
        let childSve = this.getService(params);
        //将id 赋值
        params.id = _baseOrder.raw.id;
        await childSve.createOrder(params);
      });
      return system.getResultSuccess();
    } catch (error) {
      return system.getResult(null, `系统错误 错误信息 ${error}`);
    }
  }

  /**
   * 完善信息
   * @param {*} params 
   */
  async completedOrder(params){
    //1 检查个体户是否存在

    //2 如果不存在添加保存个体户  
    //3 完善信息
  }

  getService(productType) {
    return this["orderSve_" + productType];
  }

  async apiAdd(params) {
    try {
      let sve = this.getService(params.productType);
      if (!sve) {
        return system.getResult(null, `产品类型错误${params.productType}`);
      }
      return sve.addOrder(params);
    } catch (error) {
      console.log(error);
      return system.getResult(null, "接口异常");
    }
  }

  async apiSaveInfo() {
    try {
      let sve = this.getService(params.productType);
      if (!sve) {
        return system.getResult(null, `产品类型错误${params.productType}`);
      }
      return sve.saveInfo(params);
    } catch (error) {
      console.log(error);
      return system.getResult(null, "接口异常");
    }
  }
}

module.exports = IborderbaseService;
// var task=new UserService();
// task.getUserStatisticGroupByApp().then(function(result){
//   console.log((result));
// }).catch(function(e){
//   console.log(e);
// });